#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Microsoft.Win32;
using System.IO;
using System.IO.IsolatedStorage;

using Syncfusion.Runtime.Serialization;
namespace AppStateSerializerDemo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.GroupBox GroupBox2;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Button LoadInstance;
		internal System.Windows.Forms.Button SaveInstance;
		internal System.Windows.Forms.Button LoadSingleton;
		internal System.Windows.Forms.Button SaveSingleton;
		internal System.Windows.Forms.ListBox PersistenceModeList;
		private string PersistenceStoreName = "SerializerDemoInfo";
		private string TextArea2Label = "TextArea2";
		private string TextArea1Label = "TextArea1";
		internal System.Windows.Forms.Label ModeDesc;
		internal System.Windows.Forms.Button ClearText;
		private Syncfusion.Windows.Forms.Tools.ComboBoxAutoComplete comboBoxAutoComplete1;
		private ArrayList itemsList = new ArrayList();
		private ArrayList alphaList = new ArrayList();
		private System.Windows.Forms.TextBox textBox1;
		private Syncfusion.Windows.Forms.Tools.AutoComplete autoComplete1;
		private System.Windows.Forms.Label label4;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{

			// Initializing the AppStateSerializer singleton instance's persistence mode.
			// This should be done as early as possible in the app.
			// If you do not initialize, by default, the serializer will use the Isolated Storage as the persistence medium.

			// To make the singleton use a XML file:
			AppStateSerializer.InitializeSingleton(SerializeMode.XMLFile, "GlobalState");
			// To make the singleton use a Ini file:
			//AppStateSerializer.InitializeSingleton(SerializeMode.INIFile, "GlobalState");
			// To make the singleton use the Isolated Storage:
			// The default scope (if you don't specify a scope) is IsolatedStorageScope.Assembly | IsolatedStorageScope.Domain | IsolatedStorageScope.User
			//AppStateSerializer.InitializeSingleton(SerializeMode.IsolatedStorage, "GlobalState", IsolatedStorageScope.Assembly | IsolatedStorageScope.Domain);
			// To make the singleton use the registry:
			//RegistryKey regKey = Registry.CurrentUser;
			//regKey = regKey.CreateSubKey("AppStateSerializerDemoInfo_Singleton");
			//AppStateSerializer.InitializeSingleton(SerializeMode.WindowsRegistry, regKey);

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.ClearText = new System.Windows.Forms.Button();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.GroupBox2 = new System.Windows.Forms.GroupBox();
			this.Label3 = new System.Windows.Forms.Label();
			this.PersistenceModeList = new System.Windows.Forms.ListBox();
			this.ModeDesc = new System.Windows.Forms.Label();
			this.LoadInstance = new System.Windows.Forms.Button();
			this.SaveInstance = new System.Windows.Forms.Button();
			this.LoadSingleton = new System.Windows.Forms.Button();
			this.SaveSingleton = new System.Windows.Forms.Button();
			this.comboBoxAutoComplete1 = new Syncfusion.Windows.Forms.Tools.ComboBoxAutoComplete();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.autoComplete1 = new Syncfusion.Windows.Forms.Tools.AutoComplete();
			this.label4 = new System.Windows.Forms.Label();
			this.GroupBox1.SuspendLayout();
			this.GroupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.comboBoxAutoComplete1.AutoCompleteControl)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.autoComplete1)).BeginInit();
			this.SuspendLayout();
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.textBox1,
																					this.comboBoxAutoComplete1,
																					this.ClearText,
																					this.Label2,
																					this.Label1});
			this.GroupBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.GroupBox1.Location = new System.Drawing.Point(16, 88);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(328, 240);
			this.GroupBox1.TabIndex = 1;
			this.GroupBox1.TabStop = false;
			this.GroupBox1.Text = "Contents for persistence:";
			// 
			// ClearText
			// 
			this.ClearText.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ClearText.Location = new System.Drawing.Point(88, 160);
			this.ClearText.Name = "ClearText";
			this.ClearText.Size = new System.Drawing.Size(104, 23);
			this.ClearText.TabIndex = 4;
			this.ClearText.Text = "Clear Text Areas";
			this.ClearText.Click += new System.EventHandler(this.ClearText_Click);
			// 
			// Label2
			// 
			this.Label2.Location = new System.Drawing.Point(152, 24);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(168, 16);
			this.Label2.TabIndex = 3;
			this.Label2.Text = "ComboBoxAutoComplete";
			// 
			// Label1
			// 
			this.Label1.Location = new System.Drawing.Point(16, 24);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(120, 32);
			this.Label1.TabIndex = 2;
			this.Label1.Text = "AutoCompleteEnabledTextBox";
			// 
			// GroupBox2
			// 
			this.GroupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.Label3,
																					this.PersistenceModeList,
																					this.ModeDesc,
																					this.LoadInstance,
																					this.SaveInstance,
																					this.LoadSingleton,
																					this.SaveSingleton});
			this.GroupBox2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.GroupBox2.Location = new System.Drawing.Point(384, 96);
			this.GroupBox2.Name = "GroupBox2";
			this.GroupBox2.Size = new System.Drawing.Size(288, 232);
			this.GroupBox2.TabIndex = 6;
			this.GroupBox2.TabStop = false;
			this.GroupBox2.Text = "Custom Persistence Options:";
			// 
			// Label3
			// 
			this.Label3.Location = new System.Drawing.Point(8, 24);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(136, 16);
			this.Label3.TabIndex = 1;
			this.Label3.Text = "Select Persistence Mode:";
			// 
			// PersistenceModeList
			// 
			this.PersistenceModeList.Items.AddRange(new object[] {
																	 "XML File",
																	 "Binary File",
																	 "Isolated Storage",
																	 "Registry"});
			this.PersistenceModeList.Location = new System.Drawing.Point(8, 48);
			this.PersistenceModeList.Name = "PersistenceModeList";
			this.PersistenceModeList.Size = new System.Drawing.Size(120, 69);
			this.PersistenceModeList.TabIndex = 0;
			this.PersistenceModeList.SelectedIndexChanged += new System.EventHandler(this.PersistenceModeList_SelectedIndexChanged);
			// 
			// ModeDesc
			// 
			this.ModeDesc.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.ModeDesc.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.ModeDesc.Location = new System.Drawing.Point(136, 48);
			this.ModeDesc.Name = "ModeDesc";
			this.ModeDesc.Size = new System.Drawing.Size(120, 72);
			this.ModeDesc.TabIndex = 2;
			// 
			// LoadInstance
			// 
			this.LoadInstance.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.LoadInstance.Location = new System.Drawing.Point(8, 128);
			this.LoadInstance.Name = "LoadInstance";
			this.LoadInstance.Size = new System.Drawing.Size(120, 23);
			this.LoadInstance.TabIndex = 1;
			this.LoadInstance.Text = "Load using Instance";
			this.LoadInstance.Click += new System.EventHandler(this.LoadInstance_Click);
			// 
			// SaveInstance
			// 
			this.SaveInstance.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.SaveInstance.Location = new System.Drawing.Point(136, 128);
			this.SaveInstance.Name = "SaveInstance";
			this.SaveInstance.Size = new System.Drawing.Size(120, 23);
			this.SaveInstance.TabIndex = 3;
			this.SaveInstance.Text = "Save using Instance";
			this.SaveInstance.Click += new System.EventHandler(this.SaveInstance_Click);
			// 
			// LoadSingleton
			// 
			this.LoadSingleton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.LoadSingleton.Location = new System.Drawing.Point(8, 160);
			this.LoadSingleton.Name = "LoadSingleton";
			this.LoadSingleton.Size = new System.Drawing.Size(120, 23);
			this.LoadSingleton.TabIndex = 2;
			this.LoadSingleton.Text = "Load using Singleton";
			this.LoadSingleton.Click += new System.EventHandler(this.LoadSingleton_Click);
			// 
			// SaveSingleton
			// 
			this.SaveSingleton.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.SaveSingleton.Location = new System.Drawing.Point(136, 160);
			this.SaveSingleton.Name = "SaveSingleton";
			this.SaveSingleton.Size = new System.Drawing.Size(120, 23);
			this.SaveSingleton.TabIndex = 4;
			this.SaveSingleton.Text = "Save using Singleton";
			this.SaveSingleton.Click += new System.EventHandler(this.SaveSingleton_Click);
			// 
			// comboBoxAutoComplete1
			// 
			// 
			// comboBoxAutoComplete1.AutoCompleteControl
			// 
			this.comboBoxAutoComplete1.AutoCompleteControl.AccessibleDescription = null;
			this.comboBoxAutoComplete1.AutoCompleteControl.AccessibleName = null;
			this.comboBoxAutoComplete1.AutoCompleteControl.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.comboBoxAutoComplete1.AutoCompleteControl.AdjustHeightToItemCount = true;
			this.comboBoxAutoComplete1.AutoCompleteControl.AutoAddItem = false;
			this.comboBoxAutoComplete1.AutoCompleteControl.AutoSerialize = true;
			this.comboBoxAutoComplete1.AutoCompleteControl.CategoryName = "";
			this.comboBoxAutoComplete1.AutoCompleteControl.ChangeDataManagerPosition = true;
			this.comboBoxAutoComplete1.AutoCompleteControl.OverrideCombo = true;
			this.comboBoxAutoComplete1.AutoCompleteControl.ParentForm = this.GroupBox1;
			this.comboBoxAutoComplete1.AutoCompleteControl.PreferredHeight = 200;
			this.comboBoxAutoComplete1.AutoCompleteControl.SelectedIndex = -1;
			this.comboBoxAutoComplete1.AutoCompleteControl.SelectedValue = "";
			this.comboBoxAutoComplete1.AutoCompleteControl.ShowCloseButton = true;
			this.comboBoxAutoComplete1.AutoCompleteControl.ShowGripper = true;
			this.comboBoxAutoComplete1.DropDownWidth = 192;
			this.comboBoxAutoComplete1.ItemHeight = 13;
			this.comboBoxAutoComplete1.Location = new System.Drawing.Point(128, 64);
			this.comboBoxAutoComplete1.Name = "comboBoxAutoComplete1";
			this.comboBoxAutoComplete1.ParentForm = this.GroupBox1;
			this.comboBoxAutoComplete1.Size = new System.Drawing.Size(192, 21);
			this.comboBoxAutoComplete1.TabIndex = 6;
			this.comboBoxAutoComplete1.UpdateComboSelectionProperties = true;
			// 
			// textBox1
			// 
			this.autoComplete1.SetAutoComplete(this.textBox1, Syncfusion.Windows.Forms.Tools.AutoCompleteModes.AutoSuggest);
			this.textBox1.Location = new System.Drawing.Point(16, 64);
			this.textBox1.Name = "textBox1";
			this.textBox1.TabIndex = 7;
			this.textBox1.Text = "";
			// 
			// autoComplete1
			// 
			this.autoComplete1.AccessibleDescription = null;
			this.autoComplete1.AccessibleName = null;
			this.autoComplete1.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.autoComplete1.AdjustHeightToItemCount = true;
			this.autoComplete1.AutoAddItem = false;
			this.autoComplete1.AutoSerialize = true;
			this.autoComplete1.CategoryName = "";
			this.autoComplete1.ParentForm = this;
			this.autoComplete1.PreferredHeight = 200;
			this.autoComplete1.SelectedIndex = -1;
			this.autoComplete1.SelectedValue = "";
			this.autoComplete1.ShowCloseButton = true;
			this.autoComplete1.ShowGripper = true;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(24, 16);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(344, 56);
			this.label4.TabIndex = 7;
			this.label4.Text = "Type A to begin AutoComplete-> Select the item->Choose the Persistence Mode ->Cli" +
				"ck  any of Save  buttons->Clear Text->Click on respective load Button.";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(784, 350);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label4,
																		  this.GroupBox2,
																		  this.GroupBox1});
			this.Name = "Form1";
			this.Text = "AppStateSerializer Demo";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.GroupBox1.ResumeLayout(false);
			this.GroupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.comboBoxAutoComplete1.AutoCompleteControl)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.autoComplete1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void LoadInstance_Click(object sender, System.EventArgs e)
		{
			if(!ValidateModeList())
				return;

			AppStateSerializer serializer 
				= new AppStateSerializer(this.GetSelectedMode(), this.GetPersistPath());

			this.LoadFromSerializer(serializer);
		}
		
		private void SaveInstance_Click(object sender, System.EventArgs e)
		{
			if(!ValidateModeList())
				return;

			AppStateSerializer serializer 
				= new AppStateSerializer(this.GetSelectedMode(), this.GetPersistPath());
			
			this.SaveIntoSerializer(serializer);

			serializer.PersistNow();
		}
		private void SaveIntoSerializer(AppStateSerializer serializer)
		{
			serializer.SerializeObject(this.TextArea1Label, this.textBox1.Text);
			serializer.SerializeObject(this.TextArea2Label, this.comboBoxAutoComplete1.Text);
		}

		private void LoadFromSerializer(AppStateSerializer serializer)
		{
			object text = serializer.DeserializeObject(this.TextArea1Label);
			if(text is string)
			{
				 this.textBox1.Text = (string)text;
			}
			else
				MessageBox.Show("Source not found or no data in source. Please try saving first.", "Persistence Info:", MessageBoxButtons.OK, MessageBoxIcon.Warning);

			text = serializer.DeserializeObject(this.TextArea2Label);
			if(text is string)
			{
				this.comboBoxAutoComplete1.Text = (string)text;
			}
		}

		private bool ValidateModeList()
		{
			if(this.PersistenceModeList.SelectedIndex == -1)
			{
				MessageBox.Show("Please select a persistence mode first.");
				return false;
			}
			return true;
		}
		private SerializeMode GetSelectedMode()
		{
			switch(this.PersistenceModeList.SelectedIndex)
			{
				case 0: return SerializeMode.XMLFile;break;
				case 1: return SerializeMode.BinaryFile;break;
				case 2: return SerializeMode.IsolatedStorage;break;
				case 3: return SerializeMode.WindowsRegistry;break;
				default: return SerializeMode.XMLFile;break;
			}
		}
		private object GetPersistPath()
		{
			switch(this.GetSelectedMode())
			{
				case SerializeMode.XMLFile: return this.PersistenceStoreName;
				case SerializeMode.BinaryFile: return this.PersistenceStoreName;
				case SerializeMode.IsolatedStorage: return this.PersistenceStoreName;
				case SerializeMode.WindowsRegistry: 
				{
					RegistryKey regKey = Registry.CurrentUser;
					regKey = regKey.CreateSubKey(this.PersistenceStoreName);
					return regKey;
				}
			}
			return null;
		}

		private void PersistenceModeList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			switch(this.PersistenceModeList.SelectedIndex)
			{
				case 0: this.ModeDesc.Text = "State will be saved in " + this.PersistenceStoreName + ".xml"; break;
				case 1: this.ModeDesc.Text = "State will be saved in " + this.PersistenceStoreName + ".ini"; break;
				case 2: this.ModeDesc.Text = "State will be saved in Isolated Storage scoped by the exe (assembly), Domain and User"; break;
				case 3: this.ModeDesc.Text = "State will be saved in Windows Registry, under HKEY_CURRENT_USER \\ " + this.PersistenceStoreName; break;
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			this.PersistenceModeList.SelectedIndex = 0;

			#region DataSource 
			this.alphaList.AddRange(new String[]{"A",
													"B",
													"C",
													"D",
													"E",
													"F",
													"G",
													"H",
													"I",
													"J",
													"K",
													"L",
													"M",
													"N",
													"O",
													"P",
													"Q",
													"R",
													"S",
													"T",
													"U",
													"V",
													"W",
													"X",
													"Y",
													"Z"
												});

			foreach(string s in this.alphaList)
			{
				for(int i = 0; i < 15; i++)
				{
					this.itemsList.Add(s + i.ToString());
				}
			}

			this.comboBoxAutoComplete1.AutoCompleteControl.DataSource = this.itemsList;
			this.autoComplete1.DataSource = this.itemsList;
			#endregion
		}

		private void ClearText_Click(object sender, System.EventArgs e)
		{
			 this.textBox1.Text = String.Empty;
			this.comboBoxAutoComplete1.Text = String.Empty;
		}

		private void LoadSingleton_Click(object sender, System.EventArgs e)
		{
			this.LoadFromSerializer(AppStateSerializer.GetSingleton());
		}

		private void SaveSingleton_Click(object sender, System.EventArgs e)
		{
			this.SaveIntoSerializer(AppStateSerializer.GetSingleton());
		}
	}
}
